// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Rxclock.pas' rev: 21.00

#ifndef RxclockHPP
#define RxclockHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Stdctrls.hpp>	// Pascal unit
#include <Extctrls.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Rxtimer.hpp>	// Pascal unit
#include <Rtlconsts.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxclock
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TShowClock { scDigital, scAnalog };
#pragma option pop

#pragma option push -b-
enum TPaintMode { pmPaintAll, pmHandPaint };
#pragma option pop

#pragma pack(push,1)
struct TRxClockTime
{
	
public:
	System::Word Hour;
	System::Word Minute;
	System::Word Second;
};
#pragma pack(pop)


typedef void __fastcall (__closure *TRxGetTimeEvent)(System::TObject* Sender, System::TDateTime &ATime);

class DELPHICLASS TRxClock;
class PASCALIMPLEMENTATION TRxClock : public Extctrls::TCustomPanel
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	Rxtimer::TRxTimer* FTimer;
	bool FAutoSize;
	TShowClock FShowMode;
	bool FTwelveHour;
	bool FLeadingZero;
	bool FShowSeconds;
	System::TDateTime FAlarm;
	bool FAlarmEnabled;
	bool FHooked;
	Graphics::TColor FDotsColor;
	bool FAlarmWait;
	TRxClockTime FDisplayTime;
	Types::TRect FClockRect;
	int FClockRadius;
	Types::TPoint FClockCenter;
	TRxGetTimeEvent FOnGetTime;
	Classes::TNotifyEvent FOnAlarm;
	void __fastcall TimerExpired(System::TObject* Sender);
	void __fastcall GetTime(TRxClockTime &T);
	bool __fastcall IsAlarmTime(System::TDateTime ATime);
	void __fastcall SetShowMode(TShowClock Value);
	System::Byte __fastcall GetAlarmElement(int Index);
	void __fastcall SetAlarmElement(int Index, System::Byte Value);
	void __fastcall SetDotsColor(Graphics::TColor Value);
	void __fastcall SetTwelveHour(bool Value);
	void __fastcall SetLeadingZero(bool Value);
	void __fastcall SetShowSeconds(bool Value);
	void __fastcall PaintAnalogClock(TPaintMode PaintMode);
	void __fastcall Paint3DFrame(Types::TRect &Rect);
	void __fastcall DrawAnalogFace(void);
	void __fastcall CircleClock(int MaxWidth, int MaxHeight);
	void __fastcall DrawSecondHand(int Pos);
	void __fastcall DrawFatHand(int Pos, bool HourHand);
	void __fastcall PaintTimeStr(Types::TRect &Rect, bool FullTime);
	void __fastcall ResizeFont(const Types::TRect &Rect);
	void __fastcall ResetAlarm(void);
	void __fastcall CheckAlarm(void);
	bool __fastcall FormatSettingsChange(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMCtl3DChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall WMTimeChange(Messages::TMessage &Message);
	
protected:
	DYNAMIC void __fastcall Alarm(void);
	virtual void __fastcall AlignControls(Controls::TControl* AControl, Types::TRect &Rect);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DestroyWindowHandle(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Paint(void);
	virtual System::TDateTime __fastcall GetSystemTime(void);
	virtual void __fastcall SetAutoSize(bool Value);
	
public:
	__fastcall virtual TRxClock(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxClock(void);
	void __fastcall SetAlarmTime(System::TDateTime AlarmTime);
	void __fastcall UpdateClock(void);
	
__published:
	__property bool AlarmEnabled = {read=FAlarmEnabled, write=FAlarmEnabled, default=0};
	__property System::Byte AlarmHour = {read=GetAlarmElement, write=SetAlarmElement, index=1, default=0};
	__property System::Byte AlarmMinute = {read=GetAlarmElement, write=SetAlarmElement, index=2, default=0};
	__property System::Byte AlarmSecond = {read=GetAlarmElement, write=SetAlarmElement, index=3, default=0};
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=0};
	__property BevelInner = {default=1};
	__property BevelOuter = {default=2};
	__property Graphics::TColor DotsColor = {read=FDotsColor, write=SetDotsColor, default=8421376};
	__property TShowClock ShowMode = {read=FShowMode, write=SetShowMode, default=0};
	__property bool ShowSeconds = {read=FShowSeconds, write=SetShowSeconds, default=1};
	__property bool TwelveHour = {read=FTwelveHour, write=SetTwelveHour, default=0};
	__property bool LeadingZero = {read=FLeadingZero, write=SetLeadingZero, default=1};
	__property Align = {default=0};
	__property BevelWidth = {default=1};
	__property BorderWidth = {default=0};
	__property BorderStyle = {default=0};
	__property Anchors = {default=3};
	__property Constraints;
	__property UseDockManager = {default=1};
	__property DockSite = {default=0};
	__property DragKind = {default=0};
	__property FullRepaint = {default=1};
	__property Color = {default=-16777201};
	__property Ctl3D;
	__property Cursor = {default=0};
	__property DragMode = {default=0};
	__property DragCursor = {default=-12};
	__property Enabled = {default=1};
	__property Font;
	__property ParentColor = {default=0};
	__property ParentCtl3D = {default=1};
	__property ParentFont = {default=1};
	__property ParentShowHint = {default=1};
	__property PopupMenu;
	__property ShowHint;
	__property Visible = {default=1};
	__property Classes::TNotifyEvent OnAlarm = {read=FOnAlarm, write=FOnAlarm};
	__property TRxGetTimeEvent OnGetTime = {read=FOnGetTime, write=FOnGetTime};
	__property OnClick;
	__property OnDblClick;
	__property OnMouseMove;
	__property OnMouseDown;
	__property OnMouseUp;
	__property OnDragOver;
	__property OnDragDrop;
	__property OnEndDrag;
	__property OnResize;
	__property OnContextPopup;
	__property OnStartDrag;
	__property OnCanResize;
	__property OnConstrainedResize;
	__property OnDockDrop;
	__property OnDockOver;
	__property OnEndDock;
	__property OnGetSiteInfo;
	__property OnStartDock;
	__property OnUnDock;
public:
	/* TWinControl.CreateParented */ inline __fastcall TRxClock(HWND ParentWindow) : Extctrls::TCustomPanel(ParentWindow) { }
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Rxclock */
using namespace Rxclock;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxclockHPP
