// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Rxgif.pas' rev: 21.00

#ifndef RxgifHPP
#define RxgifHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Rxgraph.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxgif
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TGIFVersion { gvUnknown, gv87a, gv89a };
#pragma option pop

typedef ShortInt TGIFBits;

#pragma option push -b-
enum TDisposalMethod { dmUndefined, dmLeave, dmRestoreBackground, dmRestorePrevious, dmReserved4, dmReserved5, dmReserved6, dmReserved7 };
#pragma option pop

#pragma pack(push,1)
struct TGIFColorItem
{
	
public:
	System::Byte Red;
	System::Byte Green;
	System::Byte Blue;
};
#pragma pack(pop)


#pragma pack(push,1)
struct TGIFColorTable
{
	
public:
	int Count;
	StaticArray<TGIFColorItem, 256> Colors;
};
#pragma pack(pop)


class DELPHICLASS TGIFImage;
class DELPHICLASS TGIFData;
class DELPHICLASS TGIFFrame;
class PASCALIMPLEMENTATION TGIFImage : public Graphics::TGraphic
{
	typedef Graphics::TGraphic inherited;
	
public:
	TGIFFrame* operator[](int Index) { return Frames[Index]; }
	
private:
	TGIFData* FImage;
	TGIFVersion FVersion;
	Classes::TList* FItems;
	int FFrameIndex;
	System::Word FScreenWidth;
	System::Word FScreenHeight;
	Graphics::TColor FBackgroundColor;
	bool FLooping;
	bool FCorrupted;
	System::Word FRepeatCount;
	Graphics::TBitmap* __fastcall GetBitmap(void);
	int __fastcall GetCount(void);
	Classes::TStrings* __fastcall GetComment(void);
	int __fastcall GetScreenWidth(void);
	int __fastcall GetScreenHeight(void);
	int __fastcall GetGlobalColorCount(void);
	void __fastcall UpdateScreenSize(void);
	void __fastcall SetComment(Classes::TStrings* Value);
	TGIFFrame* __fastcall GetFrame(int Index);
	void __fastcall SetFrameIndex(int Value);
	void __fastcall SetBackgroundColor(Graphics::TColor Value);
	void __fastcall SetLooping(bool Value);
	void __fastcall SetRepeatCount(System::Word Value);
	void __fastcall ReadSignature(Classes::TStream* Stream);
	void __fastcall DoProgress(Graphics::TProgressStage Stage, System::Byte PercentDone, const System::UnicodeString Msg);
	bool __fastcall GetCorrupted(void);
	Graphics::TColor __fastcall GetTransparentColor(void);
	Graphics::TColor __fastcall GetBackgroundColor(void);
	Graphics::TPixelFormat __fastcall GetPixelFormat(void);
	void __fastcall EncodeFrames(bool ReverseDecode);
	void __fastcall ReadStream(int Size, Classes::TStream* Stream, bool ForceDecode);
	void __fastcall WriteStream(Classes::TStream* Stream, bool WriteSize);
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	virtual void __fastcall Draw(Graphics::TCanvas* ACanvas, const Types::TRect &ARect);
	virtual bool __fastcall Equals(Graphics::TGraphic* Graphic)/* overload */;
	virtual bool __fastcall GetEmpty(void);
	virtual int __fastcall GetHeight(void);
	virtual int __fastcall GetWidth(void);
	virtual HPALETTE __fastcall GetPalette(void);
	virtual bool __fastcall GetTransparent(void);
	void __fastcall ClearItems(void);
	void __fastcall NewImage(void);
	void __fastcall UniqueImage(void);
	virtual void __fastcall ReadData(Classes::TStream* Stream);
	virtual void __fastcall SetHeight(int Value);
	virtual void __fastcall SetWidth(int Value);
	virtual void __fastcall WriteData(Classes::TStream* Stream);
	__property Graphics::TBitmap* Bitmap = {read=GetBitmap};
	
public:
	__fastcall virtual TGIFImage(void);
	__fastcall virtual ~TGIFImage(void);
	void __fastcall Clear(void);
	void __fastcall DecodeAllFrames(void);
	void __fastcall EncodeAllFrames(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall LoadFromClipboardFormat(System::Word AFormat, unsigned AData, HPALETTE APalette);
	virtual void __fastcall SaveToClipboardFormat(System::Word &AFormat, unsigned &AData, HPALETTE &APalette);
	void __fastcall LoadFromResourceName(unsigned Instance, const System::UnicodeString ResName, System::WideChar * ResType);
	void __fastcall LoadFromResourceID(unsigned Instance, int ResID, System::WideChar * ResType);
	virtual int __fastcall AddFrame(Graphics::TGraphic* Value);
	void __fastcall DeleteFrame(int Index);
	void __fastcall MoveFrame(int CurIndex, int NewIndex);
	void __fastcall Grayscale(bool ForceEncoding);
	__property Graphics::TColor BackgroundColor = {read=GetBackgroundColor, write=SetBackgroundColor, nodefault};
	__property Classes::TStrings* Comment = {read=GetComment, write=SetComment};
	__property bool Corrupted = {read=GetCorrupted, nodefault};
	__property int Count = {read=GetCount, nodefault};
	__property TGIFFrame* Frames[int Index] = {read=GetFrame/*, default*/};
	__property int FrameIndex = {read=FFrameIndex, write=SetFrameIndex, nodefault};
	__property int GlobalColorCount = {read=GetGlobalColorCount, nodefault};
	__property bool Looping = {read=FLooping, write=SetLooping, nodefault};
	__property Graphics::TPixelFormat PixelFormat = {read=GetPixelFormat, nodefault};
	__property System::Word RepeatCount = {read=FRepeatCount, write=SetRepeatCount, nodefault};
	__property int ScreenWidth = {read=GetScreenWidth, nodefault};
	__property int ScreenHeight = {read=GetScreenHeight, nodefault};
	__property Graphics::TColor TransparentColor = {read=GetTransparentColor, nodefault};
	__property TGIFVersion Version = {read=FVersion, nodefault};
	
/* Hoisted overloads: */
	
public:
	inline bool __fastcall  Equals(System::TObject* Obj){ return Graphics::TGraphic::Equals(Obj); }
	
};


class DELPHICLASS TGIFItem;
class PASCALIMPLEMENTATION TGIFFrame : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	TGIFImage* FOwner;
	Graphics::TBitmap* FBitmap;
	TGIFItem* FImage;
	Classes::TList* FExtensions;
	Types::TPoint FTopLeft;
	bool FInterlaced;
	bool FCorrupted;
	bool FGrayscale;
	Graphics::TColor FTransparentColor;
	System::Word FAnimateInterval;
	TDisposalMethod FDisposal;
	bool FLocalColors;
	Graphics::TBitmap* __fastcall GetBitmap(void);
	int __fastcall GetHeight(void);
	int __fastcall GetWidth(void);
	int __fastcall GetColorCount(void);
	Classes::TStrings* __fastcall FindComment(bool ForceCreate);
	Classes::TStrings* __fastcall GetComment(void);
	void __fastcall SetComment(Classes::TStrings* Value);
	void __fastcall SetTransparentColor(Graphics::TColor Value);
	void __fastcall SetDisposalMethod(TDisposalMethod Value);
	void __fastcall SetAnimateInterval(System::Word Value);
	void __fastcall SetTopLeft(const Types::TPoint &Value);
	void __fastcall NewBitmap(void);
	void __fastcall NewImage(void);
	void __fastcall SaveToBitmapStream(Classes::TMemoryStream* Stream);
	void __fastcall EncodeBitmapStream(Classes::TMemoryStream* Stream);
	void __fastcall EncodeRasterData(void);
	void __fastcall UpdateExtensions(void);
	void __fastcall WriteImageDescriptor(Classes::TStream* Stream);
	void __fastcall WriteLocalColorMap(Classes::TStream* Stream);
	void __fastcall WriteRasterData(Classes::TStream* Stream);
	
protected:
	__fastcall virtual TGIFFrame(TGIFImage* AOwner);
	void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	void __fastcall GrayscaleImage(bool ForceEncoding);
	
public:
	__fastcall virtual ~TGIFFrame(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Graphics::TCanvas* ACanvas, const Types::TRect &ARect, bool Transparent);
	__property System::Word AnimateInterval = {read=FAnimateInterval, write=SetAnimateInterval, nodefault};
	__property Graphics::TBitmap* Bitmap = {read=GetBitmap};
	__property int ColorCount = {read=GetColorCount, nodefault};
	__property Classes::TStrings* Comment = {read=GetComment, write=SetComment};
	__property TDisposalMethod DisposalMethod = {read=FDisposal, write=SetDisposalMethod, nodefault};
	__property bool Interlaced = {read=FInterlaced, nodefault};
	__property bool Corrupted = {read=FCorrupted, nodefault};
	__property Graphics::TColor TransparentColor = {read=FTransparentColor, write=SetTransparentColor, nodefault};
	__property Types::TPoint Origin = {read=FTopLeft, write=SetTopLeft};
	__property int Height = {read=GetHeight, nodefault};
	__property int Width = {read=GetWidth, nodefault};
};


class PASCALIMPLEMENTATION TGIFData : public Graphics::TSharedImage
{
	typedef Graphics::TSharedImage inherited;
	
private:
	Classes::TStrings* FComment;
	System::Byte FAspectRatio;
	System::Byte FBitsPerPixel;
	System::Byte FColorResBits;
	TGIFColorTable FColorMap;
	
protected:
	virtual void __fastcall FreeHandle(void);
	
public:
	__fastcall TGIFData(void);
	__fastcall virtual ~TGIFData(void);
};


class PASCALIMPLEMENTATION TGIFItem : public Graphics::TSharedImage
{
	typedef Graphics::TSharedImage inherited;
	
private:
	Classes::TMemoryStream* FImageData;
	Types::TPoint FSize;
	System::Byte FPackedFields;
	System::Byte FBitsPerPixel;
	TGIFColorTable FColorMap;
	
protected:
	virtual void __fastcall FreeHandle(void);
	
public:
	__fastcall virtual ~TGIFItem(void);
public:
	/* TObject.Create */ inline __fastcall TGIFItem(void) : Graphics::TSharedImage() { }
	
};


//-- var, const, procedure ---------------------------------------------------
#define RT_GIF L"GIF"
extern PACKAGE System::Word CF_GIF;
extern PACKAGE bool GIFLoadCorrupted;
extern PACKAGE void __fastcall rxgif_dummy(void);
extern PACKAGE System::UnicodeString __fastcall GIFVersionName(TGIFVersion Version);

}	/* namespace Rxgif */
using namespace Rxgif;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxgifHPP
