// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Rxgraph.pas' rev: 21.00

#ifndef RxgraphHPP
#define RxgraphHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Rxvclutils.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxgraph
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TMappingMethod { mmHistogram, mmQuantize, mmTrunc784, mmTrunc666, mmTripel, mmGrayscale };
#pragma option pop

class DELPHICLASS TRxGradient;
class PASCALIMPLEMENTATION TRxGradient : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FStartColor;
	Graphics::TColor FEndColor;
	Rxvclutils::TFillDirection FDirection;
	System::Byte FStepCount;
	bool FVisible;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetStartColor(Graphics::TColor Value);
	void __fastcall SetEndColor(Graphics::TColor Value);
	void __fastcall SetDirection(Rxvclutils::TFillDirection Value);
	void __fastcall SetStepCount(System::Byte Value);
	void __fastcall SetVisible(bool Value);
	
protected:
	DYNAMIC void __fastcall Changed(void);
	
public:
	__fastcall TRxGradient(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Draw(Graphics::TCanvas* Canvas, const Types::TRect &Rect);
	
__published:
	__property Rxvclutils::TFillDirection Direction = {read=FDirection, write=SetDirection, default=0};
	__property Graphics::TColor EndColor = {read=FEndColor, write=SetEndColor, default=8421504};
	__property Graphics::TColor StartColor = {read=FStartColor, write=SetStartColor, default=12632256};
	__property System::Byte StepCount = {read=FStepCount, write=SetStepCount, default=64};
	__property bool Visible = {read=FVisible, write=SetVisible, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TRxGradient(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TMappingMethod DefaultMappingMethod;
extern PACKAGE Graphics::TPixelFormat __fastcall ScreenPixelFormat(void);
extern PACKAGE int __fastcall ScreenColorCount(void);
extern PACKAGE Graphics::TPixelFormat __fastcall GetPaletteBitmapFormat(Graphics::TBitmap* Bitmap);
extern PACKAGE Graphics::TPixelFormat __fastcall GetBitmapPixelFormat(Graphics::TBitmap* Bitmap);
extern PACKAGE Classes::TMemoryStream* __fastcall BitmapToMemoryStream(Graphics::TBitmap* Bitmap, Graphics::TPixelFormat PixelFormat, TMappingMethod Method);
extern PACKAGE Classes::TStream* __fastcall BitmapToMemory(Graphics::TBitmap* Bitmap, int Colors);
extern PACKAGE void __fastcall SaveBitmapToFile(const System::UnicodeString Filename, Graphics::TBitmap* Bitmap, int Colors);
extern PACKAGE void __fastcall SetBitmapPixelFormat(Graphics::TBitmap* Bitmap, Graphics::TPixelFormat PixelFormat, TMappingMethod Method);
extern PACKAGE void __fastcall GrayscaleBitmap(Graphics::TBitmap* Bitmap);
extern PACKAGE Types::TPoint __fastcall ZoomImage(int ImageW, int ImageH, int MaxW, int MaxH, bool Stretch);
extern PACKAGE void __fastcall TileImage(Graphics::TCanvas* Canvas, const Types::TRect &Rect, Graphics::TGraphic* Image);

}	/* namespace Rxgraph */
using namespace Rxgraph;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxgraphHPP
