// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Rxnotify.pas' rev: 21.00

#ifndef RxnotifyHPP
#define RxnotifyHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Extctrls.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxnotify
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TFileChangeFilter { fnFileName, fnDirName, fnAttributes, fnSize, fnLastWrite, fnLastAccess, fnCreation, fnSecurity };
#pragma option pop

typedef Set<TFileChangeFilter, fnFileName, fnSecurity>  TFileChangeFilters;

class DELPHICLASS TRxFolderMonitor;
class DELPHICLASS TNotifyThread;
class PASCALIMPLEMENTATION TRxFolderMonitor : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	TNotifyThread* FNotifyThread;
	TFileChangeFilters FFilter;
	Extctrls::TTimer* FDelayTimer;
	unsigned FDelayTime;
	bool FMonitorSubtree;
	System::UnicodeString FFolderName;
	bool FStreamedActive;
	Classes::TNotifyEvent FOnChange;
	bool __fastcall GetActive(void);
	unsigned __fastcall GetDelayTime(void);
	void __fastcall SetActive(bool Value);
	void __fastcall SetFilter(TFileChangeFilters Value);
	void __fastcall SetMonitorSubtree(bool Value);
	void __fastcall SetFolderName(const System::UnicodeString Value);
	void __fastcall SetDelayTime(unsigned Value);
	void __fastcall Timer(System::TObject* Sender);
	void __fastcall ThreadNotification(System::TObject* Sender);
	
protected:
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall Changed(void);
	void __fastcall FreeNotifyThread(void);
	virtual void __fastcall ResetNotifyThread(bool Activate);
	
public:
	__fastcall virtual TRxFolderMonitor(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxFolderMonitor(void);
	
__published:
	__property bool Active = {read=GetActive, write=SetActive, default=0};
	__property unsigned DelayTime = {read=GetDelayTime, write=SetDelayTime, default=0};
	__property TFileChangeFilters Filter = {read=FFilter, write=SetFilter, default=27};
	__property System::UnicodeString FolderName = {read=FFolderName, write=SetFolderName};
	__property bool MonitorSubtree = {read=FMonitorSubtree, write=SetMonitorSubtree, default=1};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


class PASCALIMPLEMENTATION TNotifyThread : public Classes::TThread
{
	typedef Classes::TThread inherited;
	
private:
	unsigned FNotifyHandle;
	unsigned FEvent;
	Classes::TNotifyEvent FOnChange;
	bool FFinished;
	unsigned FLastError;
	void __fastcall CallOnChange(void);
	void __fastcall StopWaiting(void);
	
protected:
	virtual void __fastcall DoChange(void);
	virtual void __fastcall DoTerminate(void);
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TNotifyThread(const System::UnicodeString FolderName, bool WatchSubtree, TFileChangeFilters Filter);
	__fastcall virtual ~TNotifyThread(void);
	HIDESBASE void __fastcall Terminate(void);
	__property Terminated;
	__property bool Finished = {read=FFinished, nodefault};
	__property unsigned LastError = {read=FLastError, nodefault};
	__property unsigned NotifyHandle = {read=FNotifyHandle, nodefault};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TNotifyThread* __fastcall CreateNotifyThread(const System::UnicodeString FolderName, bool WatchSubtree, TFileChangeFilters Filter);

}	/* namespace Rxnotify */
using namespace Rxnotify;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxnotifyHPP
