// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Rxanifile.pas' rev: 21.00

#ifndef RxanifileHPP
#define RxanifileHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxanifile
{
//-- type declarations -------------------------------------------------------
typedef StaticArray<char, 4> TFourCC;

struct TAniTag;
typedef TAniTag *PAniTag;

#pragma pack(push,1)
struct TAniTag
{
	
public:
	TFourCC ckID;
	int ckSize;
};
#pragma pack(pop)


#pragma pack(push,1)
struct TAniHeader
{
	
public:
	int cbSizeOf;
	int cSteps;
	int cFrames;
	StaticArray<int, 4> cReserved;
	int jifRate;
	int fl;
};
#pragma pack(pop)


class DELPHICLASS TIconFrame;
class PASCALIMPLEMENTATION TIconFrame : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TIcon* FIcon;
	bool FIsIcon;
	TAniTag FTag;
	Types::TPoint FHotSpot;
	int FJiffRate;
	int FSeq;
	
public:
	__fastcall TIconFrame(int Index, int Jiff);
	__fastcall virtual ~TIconFrame(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property int JiffRate = {read=FJiffRate, nodefault};
	__property int Seq = {read=FSeq, nodefault};
};


typedef StaticArray<System::WideChar, 256> TANINAME;

class DELPHICLASS TAnimatedCursorImage;
class PASCALIMPLEMENTATION TAnimatedCursorImage : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	TAniHeader FHeader;
	TANINAME FTitle;
	TANINAME FCreator;
	Classes::TList* FIcons;
	System::Word FOriginalColors;
	void __fastcall NewImage(void);
	void __fastcall RiffReadError(void);
	Graphics::TIcon* __fastcall ReadCreateIcon(Classes::TStream* Stream, int ASize, Types::TPoint &HotSpot, bool &IsIcon);
	int __fastcall GetIconCount(void);
	Graphics::TIcon* __fastcall GetIcon(int Index);
	TIconFrame* __fastcall GetFrame(int Index);
	System::UnicodeString __fastcall GetTitle(void);
	System::UnicodeString __fastcall GetCreator(void);
	int __fastcall GetDefaultRate(void);
	void __fastcall ReadAniStream(Classes::TStream* Stream);
	void __fastcall ReadStream(int Size, Classes::TStream* Stream);
	void __fastcall WriteStream(Classes::TStream* Stream, bool WriteSize);
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	void __fastcall Draw(Graphics::TCanvas* ACanvas, const Types::TRect &ARect);
	
public:
	__fastcall TAnimatedCursorImage(void);
	__fastcall virtual ~TAnimatedCursorImage(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall Clear(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveToStream(Classes::TStream* Stream);
	virtual void __fastcall LoadFromFile(const System::UnicodeString Filename);
	void __fastcall AssignToBitmap(Graphics::TBitmap* Bitmap, Graphics::TColor BackColor, bool DecreaseColors, bool Vertical);
	__property int DefaultRate = {read=GetDefaultRate, nodefault};
	__property int IconCount = {read=GetIconCount, nodefault};
	__property Graphics::TIcon* Icons[int Index] = {read=GetIcon};
	__property TIconFrame* Frames[int Index] = {read=GetFrame};
	__property System::UnicodeString Title = {read=GetTitle};
	__property System::UnicodeString Creator = {read=GetCreator};
	__property System::Word OriginalColors = {read=FOriginalColors, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
static const ShortInt AF_ICON = 0x1;
static const ShortInt AF_SEQUENCE = 0x2;

}	/* namespace Rxanifile */
using namespace Rxanifile;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RxanifileHPP
